#if !defined(SVNCLIENTPACKEREXTENSION_H__INCLUDED)
#define SVNCLIENTPACKEREXTENSION_H__INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <jni.h>
#include "Path.h"

#include <svn_packer_extensions.h>
#include "SVNClient.h"

class Revision;

class SVNClientPackerExtension: public SVNBase {
 private:
  SVNClient* m_super;

 public:
    static SVNClientPackerExtension * getCppObject(jobject jthis);
    jlong getCppAddr();
    SVNClientPackerExtension(SVNClient* super);
    virtual ~SVNClientPackerExtension();

    jobject headRevision(jobject jthis, const char *path);
    jstring repositoryUrl(jobject jthis, const char *path);
    void rename(const char *srcPath, const char *destPath,
                  const char *message, Revision &revision, bool force);
    jlong put(jobject jthis, const char* srcPath, const char* destPath, bool forbidOverwrite, const char* message);
    jlong propertySet(jobject jthis, const char* url, const char* propName, const char* propVal, const char* message);
    jobjectArray properties(jobject jthis, const char *path, Revision &revision);
    jlong propertyRemove(jobject jthis, const char* url, const char* propName, const char* message);
    jint kind(const char *path, Revision &revision);
    void dispose(jobject jthis);
    void finalize();

 private:
    jobject createJavaRevision(jobject jthis, svn_revnum_t rev_num);

};

#endif // SVNCLIENTPACKEREXTENSION_H__INCLUDED
